
#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <fcntl.h> 
#include <sys/stat.h> 
#include <cstring> 
#include <visc.h> 
#include <tensorTypes.h> 
#include <tensorUtils.h> 

void var_0_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_convolution(t1, t2, 2, 2, 1, 1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_1_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_2_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_3_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_pool_max(t1, 2, 2, 0, 0, 2, 2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_4_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_convolution(t1, t2, 2, 2, 1, 1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_5_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_6_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_7_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_convolution(t1, t2, 1, 1, 2, 2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_8_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_9_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_10_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_mul(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_11_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_12_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_13_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_mul(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_14_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_15_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_16_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_softmax(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void root(void* input, size_t input_bytes, 
	  void* conv2d_1_w, size_t conv2d_1_w_bytes, 
	  void* conv2d_1_b, size_t conv2d_1_b_bytes, 
	  void* conv2d_2_w, size_t conv2d_2_w_bytes, 
	  void* conv2d_2_b, size_t conv2d_2_b_bytes, 
	  void* conv2d_3_w, size_t conv2d_3_w_bytes, 
	  void* conv2d_3_b, size_t conv2d_3_b_bytes, 
	  void* dense_1_w, size_t dense_1_w_bytes, 
	  void* dense_1_b, size_t dense_1_b_bytes, 
	  void* dense_2_w, size_t dense_2_w_bytes, 
	  void* dense_2_b, size_t dense_2_b_bytes){ 


  __visc__hint(visc::CPU_TARGET); 
  __visc__attributes(11, input, conv2d_1_w, conv2d_1_b, conv2d_2_w, conv2d_2_b, conv2d_3_w, conv2d_3_b, dense_1_w, dense_1_b, dense_2_w, dense_2_b, 0); 


  void* var_0 = __visc__createNodeND(0, var_0_node); 

  __visc__bindIn(var_0, 0, 0, 0); 
  __visc__bindIn(var_0, 1, 1, 0); 
  __visc__bindIn(var_0, 2, 2, 0); 
  __visc__bindIn(var_0, 3, 3, 0); 

  void* var_1 = __visc__createNodeND(0, var_1_node); 

  __visc__edge(var_0, var_1, 1, 0, 0, 0); 
  __visc__edge(var_0, var_1, 1, 1, 1, 0); 
  __visc__bindIn(var_1, 4, 2, 0); 
  __visc__bindIn(var_1, 5, 3, 0); 

  void* var_2 = __visc__createNodeND(0, var_2_node); 

  __visc__edge(var_1, var_2, 1, 0, 0, 0); 
  __visc__edge(var_1, var_2, 1, 1, 1, 0); 

  void* var_3 = __visc__createNodeND(0, var_3_node); 

  __visc__edge(var_2, var_3, 1, 0, 0, 0); 
  __visc__edge(var_2, var_3, 1, 1, 1, 0); 

  void* var_4 = __visc__createNodeND(0, var_4_node); 

  __visc__edge(var_3, var_4, 1, 0, 0, 0); 
  __visc__edge(var_3, var_4, 1, 1, 1, 0); 
  __visc__bindIn(var_4, 6, 2, 0); 
  __visc__bindIn(var_4, 7, 3, 0); 

  void* var_5 = __visc__createNodeND(0, var_5_node); 

  __visc__edge(var_4, var_5, 1, 0, 0, 0); 
  __visc__edge(var_4, var_5, 1, 1, 1, 0); 
  __visc__bindIn(var_5, 8, 2, 0); 
  __visc__bindIn(var_5, 9, 3, 0); 

  void* var_6 = __visc__createNodeND(0, var_6_node); 

  __visc__edge(var_5, var_6, 1, 0, 0, 0); 
  __visc__edge(var_5, var_6, 1, 1, 1, 0); 

  void* var_7 = __visc__createNodeND(0, var_7_node); 

  __visc__edge(var_6, var_7, 1, 0, 0, 0); 
  __visc__edge(var_6, var_7, 1, 1, 1, 0); 
  __visc__bindIn(var_7, 10, 2, 0); 
  __visc__bindIn(var_7, 11, 3, 0); 

  void* var_8 = __visc__createNodeND(0, var_8_node); 

  __visc__edge(var_7, var_8, 1, 0, 0, 0); 
  __visc__edge(var_7, var_8, 1, 1, 1, 0); 
  __visc__bindIn(var_8, 12, 2, 0); 
  __visc__bindIn(var_8, 13, 3, 0); 

  void* var_9 = __visc__createNodeND(0, var_9_node); 

  __visc__edge(var_8, var_9, 1, 0, 0, 0); 
  __visc__edge(var_8, var_9, 1, 1, 1, 0); 

  void* var_10 = __visc__createNodeND(0, var_10_node); 

  __visc__edge(var_9, var_10, 1, 0, 0, 0); 
  __visc__edge(var_9, var_10, 1, 1, 1, 0); 
  __visc__bindIn(var_10, 14, 2, 0); 
  __visc__bindIn(var_10, 15, 3, 0); 

  void* var_11 = __visc__createNodeND(0, var_11_node); 

  __visc__edge(var_10, var_11, 1, 0, 0, 0); 
  __visc__edge(var_10, var_11, 1, 1, 1, 0); 
  __visc__bindIn(var_11, 16, 2, 0); 
  __visc__bindIn(var_11, 17, 3, 0); 

  void* var_12 = __visc__createNodeND(0, var_12_node); 

  __visc__edge(var_11, var_12, 1, 0, 0, 0); 
  __visc__edge(var_11, var_12, 1, 1, 1, 0); 

  void* var_13 = __visc__createNodeND(0, var_13_node); 

  __visc__edge(var_12, var_13, 1, 0, 0, 0); 
  __visc__edge(var_12, var_13, 1, 1, 1, 0); 
  __visc__bindIn(var_13, 18, 2, 0); 
  __visc__bindIn(var_13, 19, 3, 0); 

  void* var_14 = __visc__createNodeND(0, var_14_node); 

  __visc__edge(var_13, var_14, 1, 0, 0, 0); 
  __visc__edge(var_13, var_14, 1, 1, 1, 0); 
  __visc__bindIn(var_14, 20, 2, 0); 
  __visc__bindIn(var_14, 21, 3, 0); 

  void* var_15 = __visc__createNodeND(0, var_15_node); 

  __visc__edge(var_14, var_15, 1, 0, 0, 0); 
  __visc__edge(var_14, var_15, 1, 1, 1, 0); 

  void* var_16 = __visc__createNodeND(0, var_16_node); 

  __visc__edge(var_15, var_16, 1, 0, 0, 0); 
  __visc__edge(var_15, var_16, 1, 1, 1, 0); 

  __visc__bindOut(var_16, 0, 0, 0); 
  __visc__bindOut(var_16, 1, 1, 0); 

}

struct ret_t {
  void* tensor; 
  size_t bytes; 
}; 

typedef struct __attribute__((__packed__)) {
  void* input; 
  size_t input_bytes; 
  void* conv2d_1_w; 
  size_t conv2d_1_w_bytes; 
  void* conv2d_1_b; 
  size_t conv2d_1_b_bytes; 
  void* conv2d_2_w; 
  size_t conv2d_2_w_bytes; 
  void* conv2d_2_b; 
  size_t conv2d_2_b_bytes; 
  void* conv2d_3_w; 
  size_t conv2d_3_w_bytes; 
  void* conv2d_3_b; 
  size_t conv2d_3_b_bytes; 
  void* dense_1_w; 
  size_t dense_1_w_bytes; 
  void* dense_1_b; 
  size_t dense_1_b_bytes; 
  void* dense_2_w; 
  size_t dense_2_w_bytes; 
  void* dense_2_b; 
  size_t dense_2_b_bytes; 

  struct ret_t r; 
}
RootIn;


int main(){ 

  std::string dir_prefix = std::string("../../../../../../projects/hpvm-tensor-rt/model_params/lenet_relu/"); 
  std::string input_path =  dir_prefix + std::string("input.bin"); 
  void* input = readTrainedWeights(input_path.c_str(), 0,10000,1,28,28); 
  std::string labels_path =  dir_prefix + std::string("labels.bin"); 
  uint8_t* labels = readLabels(labels_path.c_str(),10000); 
  std::string conv2d_1_w_path =  dir_prefix + std::string("conv2d_1_w.bin"); 
  void* conv2d_1_w =  readTrainedWeights(conv2d_1_w_path.c_str(), 0,32,1,5,5); 
  std::string conv2d_1_b_path =  dir_prefix + std::string("conv2d_1_b.bin"); 
  void* conv2d_1_b =  readTrainedWeights(conv2d_1_b_path.c_str(), 0,1,32,1,1); 
  std::string conv2d_2_w_path =  dir_prefix + std::string("conv2d_2_w.bin"); 
  void* conv2d_2_w =  readTrainedWeights(conv2d_2_w_path.c_str(), 0,64,32,5,5); 
  std::string conv2d_2_b_path =  dir_prefix + std::string("conv2d_2_b.bin"); 
  void* conv2d_2_b =  readTrainedWeights(conv2d_2_b_path.c_str(), 0,1,64,1,1); 
  std::string conv2d_3_w_path =  dir_prefix + std::string("conv2d_3_w.bin"); 
  void* conv2d_3_w =  readTrainedWeights(conv2d_3_w_path.c_str(), 0,64,64,3,3); 
  std::string conv2d_3_b_path =  dir_prefix + std::string("conv2d_3_b.bin"); 
  void* conv2d_3_b =  readTrainedWeights(conv2d_3_b_path.c_str(), 0,1,64,1,1); 
  std::string dense_1_w_path =  dir_prefix + std::string("dense_1_w.bin"); 
  void* dense_1_w =  readTrainedWeights(dense_1_w_path.c_str(), 0,1,1,3136,1024); 
  std::string dense_1_b_path =  dir_prefix + std::string("dense_1_b.bin"); 
  void* dense_1_b =  readTrainedWeights(dense_1_b_path.c_str(), 0,1,1024,1,1); 
  std::string dense_2_w_path =  dir_prefix + std::string("dense_2_w.bin"); 
  void* dense_2_w =  readTrainedWeights(dense_2_w_path.c_str(), 0,1,1,1024,10); 
  std::string dense_2_b_path =  dir_prefix + std::string("dense_2_b.bin"); 
  void* dense_2_b =  readTrainedWeights(dense_2_b_path.c_str(), 0,1,10,1,1); 

  __visc__init(); 
  RootIn* args = static_cast<RootIn*>(malloc(sizeof(RootIn))); 

  args->input = input; 
  args->input_bytes = 0; 
  args->conv2d_1_w = conv2d_1_w; 
  args->conv2d_1_w_bytes = 0; 
  args->conv2d_1_b = conv2d_1_b; 
  args->conv2d_1_b_bytes = 0; 
  args->conv2d_2_w = conv2d_2_w; 
  args->conv2d_2_w_bytes = 0; 
  args->conv2d_2_b = conv2d_2_b; 
  args->conv2d_2_b_bytes = 0; 
  args->conv2d_3_w = conv2d_3_w; 
  args->conv2d_3_w_bytes = 0; 
  args->conv2d_3_b = conv2d_3_b; 
  args->conv2d_3_b_bytes = 0; 
  args->dense_1_w = dense_1_w; 
  args->dense_1_w_bytes = 0; 
  args->dense_1_b = dense_1_b; 
  args->dense_1_b_bytes = 0; 
  args->dense_2_w = dense_2_w; 
  args->dense_2_w_bytes = 0; 
  args->dense_2_b = dense_2_b; 
  args->dense_2_b_bytes = 0; 

  void* dfg = __visc__launch(0, root, (void*) args); 

  __visc__wait(dfg); 

  void *result = static_cast<RootIn*>(args)->input; 
  hpvm_request_tensor(result, 0); 

  __visc__cleanup(); 
  computeAccuracy2(labels, 10000, result); 
  return 0; 

} 
