
#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <fcntl.h> 
#include <sys/stat.h> 
#include <cstring> 
#include <visc.h> 
#include <tensorTypes.h> 
#include <tensorUtils.h> 

void var_0_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_convolution(t1, t2, 2, 2, 1, 1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_1_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_2_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_3_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2, void* t3, size_t bytes_t3, void* t4, size_t bytes_t4, void* t5, size_t bytes_t5) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(5, t1, t2, t3, t4, t5, 0); 

  void *r = __visc__tensor_batchnorm(t1, t2, t3, t4, t5, 0.001); 
  __visc__return(2, r, (size_t) 0); 
}

void var_4_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_pool_max(t1, 2, 2, 0, 0, 2, 2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_5_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_group_convolution(t1, t2, 1, 1, 1, 1, 1, 32); 
  __visc__return(2, r, (size_t) 0); 
}

void var_6_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_7_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_8_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2, void* t3, size_t bytes_t3, void* t4, size_t bytes_t4, void* t5, size_t bytes_t5) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(5, t1, t2, t3, t4, t5, 0); 

  void *r = __visc__tensor_batchnorm(t1, t2, t3, t4, t5, 0.001); 
  __visc__return(2, r, (size_t) 0); 
}

void var_9_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_mul(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_10_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_11_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_12_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_mul(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_13_node(void* t1, size_t bytes_t1, void* t2, size_t bytes_t2) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(2, t1, t2, 0); 

  void *r = __visc__tensor_add(t1, t2); 
  __visc__return(2, r, (size_t) 0); 
}

void var_14_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_relu(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void var_15_node(void* t1, size_t bytes_t1) { 
  __visc__hint(visc::CUDNN_TARGET); 
  __visc__attributes(1, t1, 0); 

  void* r = __visc__tensor_softmax(t1); 
  __visc__return(2, r, (size_t) 0); 
}

void root(void* input, size_t input_bytes, 
	  void* conv2d_1_w, size_t conv2d_1_w_bytes, 
	  void* conv2d_1_b, size_t conv2d_1_b_bytes, 
	  void* batch_normalization_1_gamma, size_t batch_normalization_1_gamma_bytes, 
	  void* batch_normalization_1_beta, size_t batch_normalization_1_beta_bytes, 
	  void* batch_normalization_1_mean, size_t batch_normalization_1_mean_bytes, 
	  void* batch_normalization_1_variance, size_t batch_normalization_1_variance_bytes, 
	  void* depthwise_conv2d_1_w, size_t depthwise_conv2d_1_w_bytes, 
	  void* depthwise_conv2d_1_b, size_t depthwise_conv2d_1_b_bytes, 
	  void* batch_normalization_2_gamma, size_t batch_normalization_2_gamma_bytes, 
	  void* batch_normalization_2_beta, size_t batch_normalization_2_beta_bytes, 
	  void* batch_normalization_2_mean, size_t batch_normalization_2_mean_bytes, 
	  void* batch_normalization_2_variance, size_t batch_normalization_2_variance_bytes, 
	  void* dense_1_w, size_t dense_1_w_bytes, 
	  void* dense_1_b, size_t dense_1_b_bytes, 
	  void* dense_2_w, size_t dense_2_w_bytes, 
	  void* dense_2_b, size_t dense_2_b_bytes){ 


  __visc__hint(visc::CPU_TARGET); 
  __visc__attributes(17, input, conv2d_1_w, conv2d_1_b, batch_normalization_1_gamma, batch_normalization_1_beta, batch_normalization_1_mean, batch_normalization_1_variance, depthwise_conv2d_1_w, depthwise_conv2d_1_b, batch_normalization_2_gamma, batch_normalization_2_beta, batch_normalization_2_mean, batch_normalization_2_variance, dense_1_w, dense_1_b, dense_2_w, dense_2_b, 0); 


  void* var_0 = __visc__createNodeND(0, var_0_node); 

  __visc__bindIn(var_0, 0, 0, 0); 
  __visc__bindIn(var_0, 1, 1, 0); 
  __visc__bindIn(var_0, 2, 2, 0); 
  __visc__bindIn(var_0, 3, 3, 0); 

  void* var_1 = __visc__createNodeND(0, var_1_node); 

  __visc__edge(var_0, var_1, 1, 0, 0, 0); 
  __visc__edge(var_0, var_1, 1, 1, 1, 0); 
  __visc__bindIn(var_1, 4, 2, 0); 
  __visc__bindIn(var_1, 5, 3, 0); 

  void* var_2 = __visc__createNodeND(0, var_2_node); 

  __visc__edge(var_1, var_2, 1, 0, 0, 0); 
  __visc__edge(var_1, var_2, 1, 1, 1, 0); 

  void* var_3 = __visc__createNodeND(0, var_3_node); 

  __visc__edge(var_2, var_3, 1, 0, 0, 0); 
  __visc__edge(var_2, var_3, 1, 1, 1, 0); 
  __visc__bindIn(var_3, 6, 2, 0); 
  __visc__bindIn(var_3, 7, 3, 0); 
  __visc__bindIn(var_3, 8, 4, 0); 
  __visc__bindIn(var_3, 9, 5, 0); 
  __visc__bindIn(var_3, 10, 6, 0); 
  __visc__bindIn(var_3, 11, 7, 0); 
  __visc__bindIn(var_3, 12, 8, 0); 
  __visc__bindIn(var_3, 13, 9, 0); 

  void* var_4 = __visc__createNodeND(0, var_4_node); 

  __visc__edge(var_3, var_4, 1, 0, 0, 0); 
  __visc__edge(var_3, var_4, 1, 1, 1, 0); 

  void* var_5 = __visc__createNodeND(0, var_5_node); 

  __visc__edge(var_4, var_5, 1, 0, 0, 0); 
  __visc__edge(var_4, var_5, 1, 1, 1, 0); 
  __visc__bindIn(var_5, 14, 2, 0); 
  __visc__bindIn(var_5, 15, 3, 0); 

  void* var_6 = __visc__createNodeND(0, var_6_node); 

  __visc__edge(var_5, var_6, 1, 0, 0, 0); 
  __visc__edge(var_5, var_6, 1, 1, 1, 0); 
  __visc__bindIn(var_6, 16, 2, 0); 
  __visc__bindIn(var_6, 17, 3, 0); 

  void* var_7 = __visc__createNodeND(0, var_7_node); 

  __visc__edge(var_6, var_7, 1, 0, 0, 0); 
  __visc__edge(var_6, var_7, 1, 1, 1, 0); 

  void* var_8 = __visc__createNodeND(0, var_8_node); 

  __visc__edge(var_7, var_8, 1, 0, 0, 0); 
  __visc__edge(var_7, var_8, 1, 1, 1, 0); 
  __visc__bindIn(var_8, 18, 2, 0); 
  __visc__bindIn(var_8, 19, 3, 0); 
  __visc__bindIn(var_8, 20, 4, 0); 
  __visc__bindIn(var_8, 21, 5, 0); 
  __visc__bindIn(var_8, 22, 6, 0); 
  __visc__bindIn(var_8, 23, 7, 0); 
  __visc__bindIn(var_8, 24, 8, 0); 
  __visc__bindIn(var_8, 25, 9, 0); 

  void* var_9 = __visc__createNodeND(0, var_9_node); 

  __visc__edge(var_8, var_9, 1, 0, 0, 0); 
  __visc__edge(var_8, var_9, 1, 1, 1, 0); 
  __visc__bindIn(var_9, 26, 2, 0); 
  __visc__bindIn(var_9, 27, 3, 0); 

  void* var_10 = __visc__createNodeND(0, var_10_node); 

  __visc__edge(var_9, var_10, 1, 0, 0, 0); 
  __visc__edge(var_9, var_10, 1, 1, 1, 0); 
  __visc__bindIn(var_10, 28, 2, 0); 
  __visc__bindIn(var_10, 29, 3, 0); 

  void* var_11 = __visc__createNodeND(0, var_11_node); 

  __visc__edge(var_10, var_11, 1, 0, 0, 0); 
  __visc__edge(var_10, var_11, 1, 1, 1, 0); 

  void* var_12 = __visc__createNodeND(0, var_12_node); 

  __visc__edge(var_11, var_12, 1, 0, 0, 0); 
  __visc__edge(var_11, var_12, 1, 1, 1, 0); 
  __visc__bindIn(var_12, 30, 2, 0); 
  __visc__bindIn(var_12, 31, 3, 0); 

  void* var_13 = __visc__createNodeND(0, var_13_node); 

  __visc__edge(var_12, var_13, 1, 0, 0, 0); 
  __visc__edge(var_12, var_13, 1, 1, 1, 0); 
  __visc__bindIn(var_13, 32, 2, 0); 
  __visc__bindIn(var_13, 33, 3, 0); 

  void* var_14 = __visc__createNodeND(0, var_14_node); 

  __visc__edge(var_13, var_14, 1, 0, 0, 0); 
  __visc__edge(var_13, var_14, 1, 1, 1, 0); 

  void* var_15 = __visc__createNodeND(0, var_15_node); 

  __visc__edge(var_14, var_15, 1, 0, 0, 0); 
  __visc__edge(var_14, var_15, 1, 1, 1, 0); 

  __visc__bindOut(var_15, 0, 0, 0); 
  __visc__bindOut(var_15, 1, 1, 0); 

}

struct ret_t {
  void* tensor; 
  size_t bytes; 
}; 

typedef struct __attribute__((__packed__)) {
  void* input; 
  size_t input_bytes; 
  void* conv2d_1_w; 
  size_t conv2d_1_w_bytes; 
  void* conv2d_1_b; 
  size_t conv2d_1_b_bytes; 
  void* batch_normalization_1_gamma; 
  size_t batch_normalization_1_gamma_bytes; 
  void* batch_normalization_1_beta; 
  size_t batch_normalization_1_beta_bytes; 
  void* batch_normalization_1_mean; 
  size_t batch_normalization_1_mean_bytes; 
  void* batch_normalization_1_variance; 
  size_t batch_normalization_1_variance_bytes; 
  void* depthwise_conv2d_1_w; 
  size_t depthwise_conv2d_1_w_bytes; 
  void* depthwise_conv2d_1_b; 
  size_t depthwise_conv2d_1_b_bytes; 
  void* batch_normalization_2_gamma; 
  size_t batch_normalization_2_gamma_bytes; 
  void* batch_normalization_2_beta; 
  size_t batch_normalization_2_beta_bytes; 
  void* batch_normalization_2_mean; 
  size_t batch_normalization_2_mean_bytes; 
  void* batch_normalization_2_variance; 
  size_t batch_normalization_2_variance_bytes; 
  void* dense_1_w; 
  size_t dense_1_w_bytes; 
  void* dense_1_b; 
  size_t dense_1_b_bytes; 
  void* dense_2_w; 
  size_t dense_2_w_bytes; 
  void* dense_2_b; 
  size_t dense_2_b_bytes; 

  struct ret_t r; 
}
RootIn;

int main(){ 

  std::string dir_prefix = std::string("../../../../../../projects/hpvm-tensor-rt/model_params/depthwise_batchnorm2/"); 

  std::string input_path =  dir_prefix + std::string("input.bin"); 
  std::string labels_path =  dir_prefix + std::string("labels.bin"); 
  std::string conv2d_1_w_path =  dir_prefix + std::string("conv2d_1_w.bin"); 
  void* conv2d_1_w =  readTrainedWeights(conv2d_1_w_path.c_str(), 0,32,1,5,5); 
  std::string conv2d_1_b_path =  dir_prefix + std::string("conv2d_1_b.bin"); 
  void* conv2d_1_b =  readTrainedWeights(conv2d_1_b_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_1_gamma_path =  dir_prefix + std::string("batch_normalization_1_gamma.bin"); 
  void* batch_normalization_1_gamma =  readTrainedWeights(batch_normalization_1_gamma_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_1_beta_path =  dir_prefix + std::string("batch_normalization_1_beta.bin"); 
  void* batch_normalization_1_beta =  readTrainedWeights(batch_normalization_1_beta_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_1_mean_path =  dir_prefix + std::string("batch_normalization_1_mean.bin"); 
  void* batch_normalization_1_mean =  readTrainedWeights(batch_normalization_1_mean_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_1_variance_path =  dir_prefix + std::string("batch_normalization_1_variance.bin"); 
  void* batch_normalization_1_variance =  readTrainedWeights(batch_normalization_1_variance_path.c_str(), 0,1,32,1,1); 
  std::string depthwise_conv2d_1_w_path =  dir_prefix + std::string("depthwise_conv2d_1_w.bin"); 
  void* depthwise_conv2d_1_w =  readTrainedWeights(depthwise_conv2d_1_w_path.c_str(), 0,32,1,3,3); 
  std::string depthwise_conv2d_1_b_path =  dir_prefix + std::string("depthwise_conv2d_1_b.bin"); 
  void* depthwise_conv2d_1_b =  readTrainedWeights(depthwise_conv2d_1_b_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_2_gamma_path =  dir_prefix + std::string("batch_normalization_2_gamma.bin"); 
  void* batch_normalization_2_gamma =  readTrainedWeights(batch_normalization_2_gamma_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_2_beta_path =  dir_prefix + std::string("batch_normalization_2_beta.bin"); 
  void* batch_normalization_2_beta =  readTrainedWeights(batch_normalization_2_beta_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_2_mean_path =  dir_prefix + std::string("batch_normalization_2_mean.bin"); 
  void* batch_normalization_2_mean =  readTrainedWeights(batch_normalization_2_mean_path.c_str(), 0,1,32,1,1); 
  std::string batch_normalization_2_variance_path =  dir_prefix + std::string("batch_normalization_2_variance.bin"); 
  void* batch_normalization_2_variance =  readTrainedWeights(batch_normalization_2_variance_path.c_str(), 0,1,32,1,1); 
  std::string dense_1_w_path =  dir_prefix + std::string("dense_1_w.bin"); 
  void* dense_1_w =  readTrainedWeights(dense_1_w_path.c_str(), 0,1,1,6272,1024); 
  std::string dense_1_b_path =  dir_prefix + std::string("dense_1_b.bin"); 
  void* dense_1_b =  readTrainedWeights(dense_1_b_path.c_str(), 0,1,1024,1,1); 
  std::string dense_2_w_path =  dir_prefix + std::string("dense_2_w.bin"); 
  void* dense_2_w =  readTrainedWeights(dense_2_w_path.c_str(), 0,1,1,1024,10); 
  std::string dense_2_b_path =  dir_prefix + std::string("dense_2_b.bin"); 
  void* dense_2_b =  readTrainedWeights(dense_2_b_path.c_str(), 0,1,10,1,1); 
  void* input = readTrainedWeights(input_path.c_str(), 0,10000,1,28,28); 
  uint8_t* labels = readLabels(labels_path.c_str(),10000); 

  __visc__init(); 
  RootIn* args = static_cast<RootIn*>(malloc(sizeof(RootIn))); 

  args->input = input; 
  args->input_bytes = 0; 
  args->conv2d_1_w = conv2d_1_w; 
  args->conv2d_1_w_bytes = 0; 
  args->conv2d_1_b = conv2d_1_b; 
  args->conv2d_1_b_bytes = 0; 
  args->batch_normalization_1_gamma = batch_normalization_1_gamma; 
  args->batch_normalization_1_gamma_bytes = 0; 
  args->batch_normalization_1_beta = batch_normalization_1_beta; 
  args->batch_normalization_1_beta_bytes = 0; 
  args->batch_normalization_1_mean = batch_normalization_1_mean; 
  args->batch_normalization_1_mean_bytes = 0; 
  args->batch_normalization_1_variance = batch_normalization_1_variance; 
  args->batch_normalization_1_variance_bytes = 0; 
  args->depthwise_conv2d_1_w = depthwise_conv2d_1_w; 
  args->depthwise_conv2d_1_w_bytes = 0; 
  args->depthwise_conv2d_1_b = depthwise_conv2d_1_b; 
  args->depthwise_conv2d_1_b_bytes = 0; 
  args->batch_normalization_2_gamma = batch_normalization_2_gamma; 
  args->batch_normalization_2_gamma_bytes = 0; 
  args->batch_normalization_2_beta = batch_normalization_2_beta; 
  args->batch_normalization_2_beta_bytes = 0; 
  args->batch_normalization_2_mean = batch_normalization_2_mean; 
  args->batch_normalization_2_mean_bytes = 0; 
  args->batch_normalization_2_variance = batch_normalization_2_variance; 
  args->batch_normalization_2_variance_bytes = 0; 
  args->dense_1_w = dense_1_w; 
  args->dense_1_w_bytes = 0; 
  args->dense_1_b = dense_1_b; 
  args->dense_1_b_bytes = 0; 
  args->dense_2_w = dense_2_w; 
  args->dense_2_w_bytes = 0; 
  args->dense_2_b = dense_2_b; 
  args->dense_2_b_bytes = 0; 

  void* dfg = __visc__launch(0, root, (void*) args); 

  __visc__wait(dfg); 

  void *result = static_cast<RootIn*>(args)->input; 
  hpvm_request_tensor(result, 0); 

  __visc__cleanup(); 
  computeAccuracy2(labels, 10000, result); 
  return 0; 

} 
