
#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <fcntl.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <string.h> 
#include "../../../tensor_runtime/include/tensor_runtime.h" 
#include "../../include/utils.h" 

int main(){ 

llvm_hpvm_initTensorRt(0); 



std::string dir_prefix = std::string("lenet_hpvm/"); 
std::string input_path =  dir_prefix + std::string("input.bin"); 
void* input = readTrainedWeights(input_path.c_str(), 0,10000,1,28,28); 
std::string labels_path =  dir_prefix + std::string("labels.bin"); 
uint8_t* labels = readLabels(labels_path.c_str(),10000); 
std::string conv2d_1_w_path =  dir_prefix + std::string("conv2d_1_w.bin"); 
void* conv2d_1_w =  readTrainedWeights(conv2d_1_w_path.c_str(), 0,32,1,5,5); 
std::string conv2d_1_b_path =  dir_prefix + std::string("conv2d_1_b.bin"); 
void* conv2d_1_b =  readTrainedWeights(conv2d_1_b_path.c_str(), 0,1,32,1,1); 
std::string conv2d_2_w_path =  dir_prefix + std::string("conv2d_2_w.bin"); 
void* conv2d_2_w =  readTrainedWeights(conv2d_2_w_path.c_str(), 0,64,32,5,5); 
std::string conv2d_2_b_path =  dir_prefix + std::string("conv2d_2_b.bin"); 
void* conv2d_2_b =  readTrainedWeights(conv2d_2_b_path.c_str(), 0,1,64,1,1); 
std::string conv2d_3_w_path =  dir_prefix + std::string("conv2d_3_w.bin"); 
void* conv2d_3_w =  readTrainedWeights(conv2d_3_w_path.c_str(), 0,64,64,3,3); 
std::string conv2d_3_b_path =  dir_prefix + std::string("conv2d_3_b.bin"); 
void* conv2d_3_b =  readTrainedWeights(conv2d_3_b_path.c_str(), 0,1,64,1,1); 
std::string dense_1_w_path =  dir_prefix + std::string("dense_1_w.bin"); 
void* dense_1_w =  readTrainedWeights(dense_1_w_path.c_str(), 0,1,1,3136,1024); 
std::string dense_1_b_path =  dir_prefix + std::string("dense_1_b.bin"); 
void* dense_1_b =  readTrainedWeights(dense_1_b_path.c_str(), 0,1,1024,1,1); 
std::string dense_2_w_path =  dir_prefix + std::string("dense_2_w.bin"); 
void* dense_2_w =  readTrainedWeights(dense_2_w_path.c_str(), 0,1,1,1024,10); 
std::string dense_2_b_path =  dir_prefix + std::string("dense_2_b.bin"); 
void* dense_2_b =  readTrainedWeights(dense_2_b_path.c_str(), 0,1,10,1,1); 


void* var_0 = ConvLayer_PROMISE(input, 0.0, 1.0, conv2d_1_w, -0.23503187, 0.22027442, conv2d_1_b, -0.059452552, 0.05141998, 2, 2, 1, 1, 0, 2, 1, 0.0, 1.4499073, 9); 
void* var_1 = ConvLayer_PROMISE(var_0, 0.0, 1.4499073, conv2d_2_w, -0.16616209, 0.1624253, conv2d_2_b, -0.060705345, 0.07730491, 2, 2, 1, 1, -1, 0, 1, 0.0, 4.394469, 9); 
void* var_2 = ConvLayer_PROMISE(var_1, 0.0, 4.394469, conv2d_3_w, -0.17305803, 0.16375193, conv2d_3_b, -0.01982658, 0.05104504, 1, 1, 2, 2, -1, 0, 1, 0.0, 8.275149, 9); 
void* var_3 = FCLayer_PROMISE(var_2, 0.0, 8.275149, dense_1_w, -0.10478318, 0.10765447, dense_1_b, -0.0300005, 0.03506347, 1, 0.0, 9.308638, 9); 
void* var_4 = FCLayer_PROMISE(var_3, 0.0, 9.308638, dense_2_w, -0.1958274, 0.14691855, dense_2_b, -0.007710449, 0.039741356, 1, 0.0, 36.96972, 9); 
void* var_5 = tensorSoftmax(var_4); 

computeAccuracy2(labels,10000,var_5); 

llvm_hpvm_cleanupTensorRt(); 

return 0; 

}
