
#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <fcntl.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <string.h> 
#include "../../tensor_runtime/include/tensor_runtime.h" 
#include "../include/utils.h" 

int main(){ 

llvm_hpvm_initTensorRt(0); 


std::string dir_prefix = std::string("lenet_hpvm/"); 
std::string input_path =  dir_prefix + std::string("input.bin"); 
void* input = readTrainedWeights(input_path.c_str(), 0,10000,1,28,28); 
std::string labels_path =  dir_prefix + std::string("labels.bin"); 
uint8_t* labels = readLabels(labels_path.c_str(),10000); 
std::string conv2d_1_w_path =  dir_prefix + std::string("conv2d_1_w.bin"); 
void* conv2d_1_w =  readTrainedWeights(conv2d_1_w_path.c_str(), 0,32,1,5,5); 
std::string conv2d_1_b_path =  dir_prefix + std::string("conv2d_1_b.bin"); 
void* conv2d_1_b =  readTrainedWeights(conv2d_1_b_path.c_str(), 0,1,32,1,1); 
std::string conv2d_2_w_path =  dir_prefix + std::string("conv2d_2_w.bin"); 
void* conv2d_2_w =  readTrainedWeights(conv2d_2_w_path.c_str(), 0,64,32,5,5); 
std::string conv2d_2_b_path =  dir_prefix + std::string("conv2d_2_b.bin"); 
void* conv2d_2_b =  readTrainedWeights(conv2d_2_b_path.c_str(), 0,1,64,1,1); 
std::string conv2d_3_w_path =  dir_prefix + std::string("conv2d_3_w.bin"); 
void* conv2d_3_w =  readTrainedWeights(conv2d_3_w_path.c_str(), 0,64,64,3,3); 
std::string conv2d_3_b_path =  dir_prefix + std::string("conv2d_3_b.bin"); 
void* conv2d_3_b =  readTrainedWeights(conv2d_3_b_path.c_str(), 0,1,64,1,1); 
std::string dense_1_w_path =  dir_prefix + std::string("dense_1_w.bin"); 
void* dense_1_w =  readTrainedWeights(dense_1_w_path.c_str(), 0,1,1,3136,1024); 
std::string dense_1_b_path =  dir_prefix + std::string("dense_1_b.bin"); 
void* dense_1_b =  readTrainedWeights(dense_1_b_path.c_str(), 0,1,1024,1,1); 
std::string dense_2_w_path =  dir_prefix + std::string("dense_2_w.bin"); 
void* dense_2_w =  readTrainedWeights(dense_2_w_path.c_str(), 0,1,1,1024,10); 
std::string dense_2_b_path =  dir_prefix + std::string("dense_2_b.bin"); 
void* dense_2_b =  readTrainedWeights(dense_2_b_path.c_str(), 0,1,10,1,1); 


void* var_0 = tensorConvolution(input, conv2d_1_w, 2, 2, 1, 1, 1, 0); 
void* var_1 = tensorAdd(var_0, conv2d_1_b); 
void* var_2 = tensorRelu(var_1); 
void* var_3 = tensorPooling(var_2,0,2,2,0,0,2,2); 
void* var_4 = tensorConvolution(var_3, conv2d_2_w, 2, 2, 1, 1, 1, 0); 
void* var_5 = tensorAdd(var_4, conv2d_2_b); 
void* var_6 = tensorRelu(var_5); 
void* var_8 = tensorConvolution(var_6, conv2d_3_w, 1, 1, 2, 2, 1, 0); 
void* var_9 = tensorAdd(var_8, conv2d_3_b); 
void* var_10 = tensorRelu(var_9); 
void* var_12 = tensorGemmGPU(var_10, dense_1_w); 
void* var_13 = tensorAdd(var_12, dense_1_b); 
void* var_14 = tensorRelu(var_13); 
void* var_15 = tensorGemmGPU(var_14, dense_2_w); 
void* var_16 = tensorAdd(var_15, dense_2_b); 
void* var_17 = tensorRelu(var_16); 
void* var_18 = tensorSoftmax(var_17); 

computeAccuracy2(labels,10000,var_18); 

llvm_hpvm_cleanupTensorRt(); 

return 0; 

}
